#include <stdio.h>
#include <stdlib.h>

/* rjesenje a) dijela zadatka */

int f(int i) { return i * i * (i - 1); }
 
int **generiraj(int m, int n)
{
  /* pojedina dijagonala je odredena zbrojem indeksa; i je redni broj celije unutar dijagonale;
     r i s su indeksi retka i stupca za danu celiju unutar dijagonale; rbr globalni redni broj celije */
  int zbroj, i, r, s, rbr = 0;

  int **a = (int **)malloc(m * sizeof(int *));
  for (i = 0; i < m; ++i)
    a[i] = (int *)malloc(n * sizeof(int));

  /* zbroj koji odreduje dijagonalu je najveci za onu dijagonalu koja ukljucuje
     "posljednju" celiju matrice, tj. onu u donjem desnom uglu, ciji je indeks m - 1, n - 1 */
  for (zbroj = 0; zbroj <= n + m - 2; ++zbroj)
  { 
    /* sada prolazimo celijama unutar dijagonale */
    for (i = 0; i <= zbroj; ++i)
    {
      /* smjer ispune ovisi o parnosti rednog broja trenutne dijagonale */
      if (zbroj % 2 == 0)
      { r = zbroj - i; s = i;  } /* mogli smo kao dolje, sa zarezom */
      else
        r = i, s = zbroj - i;    /* mogli smo kao gore, bez zareza */
     
      if (r < m && s < n)
        a[r][s] =  f(rbr++);
    }
  }

  return a;
}



/* rjesenje b) dijela zadatka */

void spremi(int **a, int m, int n)
{
  int i, j;
  FILE *h = fopen("izlaz.txt", "w");
  for (j = 0; j < n; ++j)
  {  
    for (i = 0; i < m; ++i)
      fprintf(h, "%d ", a[i][j]);
    fprintf(h, "\n");
  } 
  fclose(h);
}

int main()
{
   
}