#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<ctype.h>

#define MATRIX_DIM 15
#define SMIJER 1
#define BROJ_ROTACIJA 1
#define BROJ_RS 3

void mapiraj(char ulaz[], char **matrica, int dimenzija, int broj_rotacija, int smjer, int broj_rs){

//napunimo matricu znakovima iz ulaza

int i,j;
char tmp, tmp1, tmp2, tmp3;

for(i=0;i<dimenzija;i++)
    for(j=0;j<dimenzija;j++)
        matrica[i][j] = ulaz[(i*dimenzija+j)%strlen(ulaz)];

//rotiramo matricu u smjeru kazaljke na satu (smjer == 1) ili u smjeru obrnutom od kazaljke na satu (smjer == -1)

if(smjer!=1 && smjer!=-1){
    printf("smjer mora imati vrijednost 1 ili -1!");
    return;
}

for(i=0;i<broj_rotacija;i++){
   if(smjer == 1){
         tmp = matrica[0][dimenzija-1];
         tmp1 = matrica[dimenzija-1][dimenzija-1];
         tmp2 = matrica[dimenzija-1][0];
    for(i=dimenzija-1;i>0;i--){
        matrica[0][i] = matrica[0][i-1];
    }
     for(i=dimenzija-1;i>0;i--){
        matrica[i][dimenzija-1] = matrica[i-1][dimenzija-1];
     }
      for(i=dimenzija-1;i>0;i--){
        matrica[dimenzija-1][dimenzija-1-i] = matrica[dimenzija-1][dimenzija-1-i+1];
      }
       for(i=dimenzija-1;i>0;i--){
        matrica[dimenzija-1-i][0] = matrica[dimenzija-1-i+1][0];
    }

    matrica[1][dimenzija-1] = tmp;
    matrica[dimenzija-1][dimenzija-2] = tmp1;
    matrica[dimenzija-2][0] = tmp2;
  }
    else if(smjer == -1){

         tmp = matrica[0][0];
    for(i=1;i<dimenzija;i++){
        matrica[0][i-1] = matrica[0][i];
    }
     for(i=1;i<dimenzija;i++){
        matrica[i-1][dimenzija-1] = matrica[i][dimenzija-1];
     }
      for(i=dimenzija-1;i>0;i--){
        matrica[dimenzija-1][i] = matrica[dimenzija-1][i-1];
      }
       for(i=dimenzija-1;i>0;i--){
        matrica[i][0] = matrica[i-1][0];
    }

    matrica[1][0] = tmp;

   }
}

if(smjer == 1){
        //zamijenimo prvi redak sa broj_redka
    for(i = 0;i<dimenzija;i++){
        tmp = matrica[0][i];
        matrica[0][i] = matrica[broj_rs][i];
        matrica[broj_rs][i] = tmp;
    }
}
else if(smjer == -1){
     //zamijenimo prvi stupac sa broj_stupca

     for(i = 0;i<dimenzija;i++){
        tmp = matrica[i][0];
        matrica[i][0] = matrica[i][broj_rs];
        matrica[i][broj_rs] = tmp;
    }

}

//promijenimo velicine slova i brojeve

for(i=0;i<dimenzija;i++)
    for(j=0;j<dimenzija;j++)
            if(islower(matrica[i][j]))
                ulaz[i*dimenzija+j] = toupper(matrica[i][j]);
             else if(isupper(matrica[i][j]))
                ulaz[i*dimenzija+j] = tolower(matrica[i][j]);
             else if(isdigit(matrica[i][j]))
                ulaz[i*dimenzija+j] = (((matrica[i][j]-'0')+1)%10)+'0';

     ulaz[dimenzija*dimenzija] = '\0';

    printf("String\n%s",ulaz);

}


int provjeri(char *ulaz, int dimenzija, int broj_rotacija, int smjer, int broj_redka, FILE *f){

char tmp[MATRIX_DIM*MATRIX_DIM+1];
int velicina_ulaza = strlen(ulaz), broj,i;

char ** matrica = (char **) malloc (MATRIX_DIM*sizeof(char*));


for(i=0;i<MATRIX_DIM;i++)
    matrica[i] = (char *) malloc (MATRIX_DIM*sizeof(char));


mapiraj(ulaz,matrica,MATRIX_DIM,broj_rotacija,smjer,broj_redka);

 while ( fread(tmp, sizeof(char), strlen(ulaz)+1, f ) > 0){
        if (!strcmp(tmp, ulaz))
        {

             fread(&broj,sizeof(int),1,f);
             if(!velicina_ulaza == broj)
                continue;

            for(i=0;i<MATRIX_DIM;i++)
                    free(matrica[i]);
            free(matrica);

           return 1;
        }
         fread(&broj,sizeof(int),1,f);
 }

fwrite(ulaz, sizeof(char), strlen(ulaz)+1, f);
fwrite(&velicina_ulaza,sizeof(int),1,f);

for(i=0;i<MATRIX_DIM;i++)
    free(matrica[i]);
free(matrica);

return 2;

}

void procitaj(FILE *f){
char tmp[MATRIX_DIM*MATRIX_DIM+1];
int velicina_ulaza;
rewind(f);

while ( fread(tmp, sizeof(char), MATRIX_DIM*MATRIX_DIM+1, f ) > 0){
    printf("%s\n",tmp);
    fread(&velicina_ulaza,sizeof(int),1,f);
    printf("V: %d\n\n",velicina_ulaza);
}

}


int main(void){

char ulaz[MATRIX_DIM*MATRIX_DIM+1] = "prvi";//prvi
int i, izlaz;

FILE *out = fopen("baza.dat", "r+b");

izlaz = provjeri(ulaz,MATRIX_DIM,BROJ_ROTACIJA,SMIJER,BROJ_RS,out);

printf("\nIzlaz: %d\n",izlaz);

procitaj(out);

fclose(out);

return 0;
}
